Index: src/UIElements/Dialog.hpp
===================================================================
--- src/UIElements/Dialog.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/UIElements/Dialog.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -12,8 +12,8 @@
 #include<list>
 
-class MoleculeListClass;
+class atom;
+class element;
 class molecule;
 class Vector;
-class element;
 
 class Dialog
@@ -23,10 +23,14 @@
   virtual ~Dialog();
 
-  virtual void queryInt(const char *, int *)=0;
-  virtual void queryDouble(const char*,double *)=0;
-  virtual void queryString(const char*, std::string *)=0;
-  virtual void queryMolecule(const char*,molecule**,MoleculeListClass*)=0;
-  virtual void queryVector(const char*,Vector *,const double *const,bool)=0;
-  virtual void queryElement(const char*,const element **)=0;
+  virtual void queryEmpty(const char *, std::string = "")=0;
+  virtual void queryBoolean(const char *, bool *, std::string = "")=0;
+  virtual void queryInt(const char *, int *, std::string = "")=0;
+  virtual void queryDouble(const char*,double *, std::string = "")=0;
+  virtual void queryString(const char*, std::string *, std::string = "")=0;
+  virtual void queryAtom(const char*,atom**,std::string = "")=0;
+  virtual void queryMolecule(const char*,molecule**, std::string = "")=0;
+  virtual void queryVector(const char*,Vector *,const double *const,bool, std::string = "")=0;
+  virtual void queryBox(const char*,double ** const, std::string = "")=0;
+  virtual void queryElement(const char*,const element **, std::string = "")=0;
 
   virtual bool display();
@@ -46,5 +50,5 @@
   class Query {
   public:
-    Query(std::string _title);
+    Query(std::string _title, std::string _description = "");
     virtual ~Query();
     virtual bool handle()=0;
@@ -52,12 +56,35 @@
   protected:
     const std::string getTitle() const;
+    const std::string getDescription() const;
   private:
-    std::string title;
+    std::string title;  //!< short title of the query
+    std::string description; //!< longer description for tooltips or for help
+  };
+
+  // Empty Query is just meant for showing text, such as version, help, initial message or alike
+  class EmptyQuery : public Query {
+  public:
+    EmptyQuery(std::string title, std::string _description = "");
+    virtual ~EmptyQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
   };
 
   //Specialized classes for certain types. GUI-Types are not specialized at this time
+  class BooleanQuery : public Query {
+  public:
+    BooleanQuery(std::string title,bool *_target, std::string _description = "");
+    virtual ~BooleanQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
+  protected:
+    bool tmp;
+  private:
+    bool *target;
+  };
+
   class IntQuery : public Query {
   public:
-    IntQuery(std::string title,int *_target);
+    IntQuery(std::string title,int *_target, std::string _description = "");
     virtual ~IntQuery();
     virtual bool handle()=0;
@@ -71,5 +98,5 @@
   class DoubleQuery : public Query {
   public:
-    DoubleQuery(std::string title,double *_target);
+    DoubleQuery(std::string title,double *_target, std::string _description = "");
     virtual ~DoubleQuery();
     virtual bool handle()=0;
@@ -83,5 +110,5 @@
   class StringQuery : public Query {
   public:
-    StringQuery(std::string title,std::string *_target);
+    StringQuery(std::string title,std::string *_target, std::string _description = "");
     virtual ~StringQuery();
     virtual bool handle()=0;
@@ -93,8 +120,7 @@
   };
 
-
   class MoleculeQuery : public Query {
   public:
-    MoleculeQuery(std::string title, molecule **_target, MoleculeListClass *_molecules);
+    MoleculeQuery(std::string title, molecule **_target, std::string _description = "");
     virtual ~MoleculeQuery();
     virtual bool handle()=0;
@@ -102,12 +128,23 @@
   protected:
     molecule *tmp;
-    MoleculeListClass *molecules;
   private:
     molecule **target;
   };
 
+  class AtomQuery : public Query {
+  public:
+    AtomQuery(std::string title, atom **_target, std::string _description = "");
+    virtual ~AtomQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
+  protected:
+    atom *tmp;
+  private:
+    atom **target;
+  };
+
   class VectorQuery : public Query {
   public:
-      VectorQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check);
+      VectorQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description = "");
       virtual ~VectorQuery();
       virtual bool handle()=0;
@@ -121,7 +158,19 @@
   };
 
+  class BoxQuery : public Query {
+  public:
+      BoxQuery(std::string title,double ** const _cellSize, std::string _description = "");
+      virtual ~BoxQuery();
+      virtual bool handle()=0;
+      virtual void setResult();
+    protected:
+      double *tmp;
+    private:
+      double **target;
+  };
+
   class ElementQuery : public Query {
   public:
-    ElementQuery(std::string title, const element**_target);
+    ElementQuery(std::string title, const element**_target, std::string _description = "");
     virtual ~ElementQuery();
     virtual bool handle()=0;
@@ -140,3 +189,4 @@
 };
 
+
 #endif /* DIALOG_HPP_ */
Index: src/UIElements/MainWindow.hpp
===================================================================
--- src/UIElements/MainWindow.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/UIElements/MainWindow.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -25,19 +25,4 @@
 };
 
-/**
- * The type of menuPopulators
- */
-typedef void (*MenuMaker)(Menu*,MoleculeListClass*, config*, periodentafel*);
-
-/**
- * This contains all Functions that are used to create the menus.
- * Needs a specific funtion for each menu. All populators will be called
- * by the UIFactory upon creation of the main menu. Thus the actuall construction
- * of the Menus can be kept independent of the concrete type of UI that is being
- * built.
- */
-struct menuPopulaters{
-  MenuMaker MakeEditMoleculesMenu;
-};
 
 #endif /* MAINWINDOW_HPP_ */
Index: src/UIElements/TextDialog.cpp
===================================================================
--- src/UIElements/TextDialog.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/UIElements/TextDialog.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -8,13 +8,20 @@
 #include <iostream>
 
+#include <Descriptors/AtomDescriptor.hpp>
+#include <Descriptors/AtomIdDescriptor.hpp>
+#include <Descriptors/MoleculeDescriptor.hpp>
+#include <Descriptors/MoleculeIdDescriptor.hpp>
 #include "UIElements/TextDialog.hpp"
 
 #include "World.hpp"
 #include "periodentafel.hpp"
-#include "atom.hpp"
-#include "molecule.hpp"
 #include "log.hpp"
 #include "verbose.hpp"
 
+#include "atom.hpp"
+#include "element.hpp"
+#include "molecule.hpp"
+#include "vector.hpp"
+
 using namespace std;
 
@@ -29,32 +36,59 @@
 
 
-void TextDialog::queryInt(const char* title, int* target){
-  registerQuery(new IntTextQuery(title,target));
-}
-
-void TextDialog::queryDouble(const char* title, double* target){
-  registerQuery(new DoubleTextQuery(title,target));
-}
-
-void TextDialog::queryString(const char* title, string* target){
-  registerQuery(new StringTextQuery(title,target));
-}
-
-void TextDialog::queryMolecule(const char* title, molecule **target, MoleculeListClass *molecules) {
-  registerQuery(new MoleculeTextQuery(title,target,molecules));
-}
-
-void TextDialog::queryVector(const char* title, Vector *target,const double *const cellSize, bool check) {
-  registerQuery(new VectorTextQuery(title,target,cellSize,check));
-}
-
-void TextDialog::queryElement(const char* title, const element **target){
-  registerQuery(new ElementTextQuery(title,target));
+void TextDialog::queryEmpty(const char* title, string description){
+  registerQuery(new EmptyTextQuery(title,description));
+}
+
+void TextDialog::queryBoolean(const char* title, bool* target, string description){
+  registerQuery(new BooleanTextQuery(title,target,description));
+}
+
+void TextDialog::queryInt(const char* title, int* target, string description){
+  registerQuery(new IntTextQuery(title,target,description));
+}
+
+void TextDialog::queryDouble(const char* title, double* target, string description){
+  registerQuery(new DoubleTextQuery(title,target,description));
+}
+
+void TextDialog::queryString(const char* title, string* target, string description){
+  registerQuery(new StringTextQuery(title,target,description));
+}
+
+void TextDialog::queryAtom(const char* title, atom **target, string description) {
+  registerQuery(new AtomTextQuery(title,target,description));
+}
+
+void TextDialog::queryMolecule(const char* title, molecule **target, string description) {
+  registerQuery(new MoleculeTextQuery(title,target,description));
+}
+
+void TextDialog::queryVector(const char* title, Vector *target,const double *const cellSize, bool check, string description) {
+  registerQuery(new VectorTextQuery(title,target,cellSize,check,description));
+}
+
+void TextDialog::queryBox(const char* title,double ** const cellSize, string description) {
+  registerQuery(new BoxTextQuery(title,cellSize,description));
+}
+
+void TextDialog::queryElement(const char* title, const element **target, string description){
+  registerQuery(new ElementTextQuery(title,target,description));
 }
 
 /************************** Query Infrastructure ************************/
 
-TextDialog::IntTextQuery::IntTextQuery(string title,int *_target) :
-    Dialog::IntQuery(title,_target)
+TextDialog::EmptyTextQuery::EmptyTextQuery(string title, std::string _description) :
+    Dialog::EmptyQuery(title,_description)
+{}
+
+TextDialog::EmptyTextQuery::~EmptyTextQuery() {}
+
+bool TextDialog::EmptyTextQuery::handle() {
+  cout << "Message of " << getTitle() << ":\n" << getDescription() << "\n";
+  return true;
+}
+
+TextDialog::IntTextQuery::IntTextQuery(string title, int * _target, std::string _description) :
+    Dialog::IntQuery(title,_target,_description)
 {}
 
@@ -79,6 +113,35 @@
 }
 
-TextDialog::StringTextQuery::StringTextQuery(string title,string *_target) :
-    Dialog::StringQuery(title,_target)
+TextDialog::BooleanTextQuery::BooleanTextQuery(string title, bool * _target, std::string _description) :
+    Dialog::BooleanQuery(title,_target,_description)
+{}
+
+TextDialog::BooleanTextQuery::~BooleanTextQuery() {}
+
+bool TextDialog::BooleanTextQuery::handle() {
+  bool badInput = false;
+  char input = ' ';
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> input;
+    if ((input == 'y' ) || (input == 'Y')) {
+      tmp = true;
+    } else if ((input == 'n' ) || (input == 'N')) {
+      tmp = false;
+    } else {
+      badInput=true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not of [yYnN]!" << endl;
+    }
+  } while(badInput);
+  // clear the input buffer of anything still in the line
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return true;
+}
+
+TextDialog::StringTextQuery::StringTextQuery(string title,string *_target, std::string _description) :
+    Dialog::StringQuery(title,_target,_description)
 {}
 
@@ -91,6 +154,6 @@
 }
 
-TextDialog::DoubleTextQuery::DoubleTextQuery(string title,double *_target) :
-    Dialog::DoubleQuery(title,_target)
+TextDialog::DoubleTextQuery::DoubleTextQuery(string title,double *_target, std::string _description) :
+    Dialog::DoubleQuery(title,_target,_description)
 {}
 
@@ -114,6 +177,38 @@
 }
 
-TextDialog::MoleculeTextQuery::MoleculeTextQuery(string title, molecule **_target, MoleculeListClass *_molecules) :
-    Dialog::MoleculeQuery(title,_target,_molecules)
+TextDialog::AtomTextQuery::AtomTextQuery(string title, atom **_target, std::string _description) :
+    Dialog::AtomQuery(title,_target,_description)
+{}
+
+TextDialog::AtomTextQuery::~AtomTextQuery() {}
+
+bool TextDialog::AtomTextQuery::handle() {
+  int idxOfAtom=0;
+  bool badInput = false;
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> idxOfAtom;
+    if(cin.fail()){
+      badInput = true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not a number!" << endl;
+      continue;
+    }
+
+    tmp = World::getInstance().getAtom(AtomById(idxOfAtom));
+    if(!tmp && idxOfAtom!=-1){
+      Log() << Verbose(0) << "Invalid Atom Index" << endl;
+      badInput = true;
+    }
+
+  } while(badInput);
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return (idxOfAtom!=-1);
+}
+
+TextDialog::MoleculeTextQuery::MoleculeTextQuery(string title, molecule **_target, std::string _description) :
+    Dialog::MoleculeQuery(title,_target,_description)
 {}
 
@@ -135,5 +230,5 @@
     }
 
-    tmp = molecules->ReturnIndex(idxOfMol);
+    tmp = World::getInstance().getMolecule(MoleculeById(idxOfMol));
     if(!tmp && idxOfMol!=-1){
       Log() << Verbose(0) << "Invalid Molecule Index" << endl;
@@ -146,6 +241,6 @@
 }
 
-TextDialog::VectorTextQuery::VectorTextQuery(std::string title, Vector *_target, const double *const _cellSize, bool _check) :
-    Dialog::VectorQuery(title,_target,_cellSize,_check)
+TextDialog::VectorTextQuery::VectorTextQuery(std::string title, Vector *_target, const double *const _cellSize, bool _check, std::string _description) :
+    Dialog::VectorQuery(title,_target,_cellSize,_check,_description)
 {}
 
@@ -168,7 +263,24 @@
 }
 
-
-TextDialog::ElementTextQuery::ElementTextQuery(std::string title, const element **target) :
-    Dialog::ElementQuery(title,target)
+TextDialog::BoxTextQuery::BoxTextQuery(std::string title, double ** const _cellSize, std::string _description) :
+    Dialog::BoxQuery(title,_cellSize,_description)
+{}
+
+TextDialog::BoxTextQuery::~BoxTextQuery()
+{}
+
+bool TextDialog::BoxTextQuery::handle() {
+  Log() << Verbose(0) << getTitle();
+
+  std::string coords[6] = {"xx","xy","xz", "yy", "yz", "zz"};
+  for (int i=0;i<6;i++) {
+    Log() << Verbose(0) << coords[i] << ": ";
+    cin >> tmp[i];
+  }
+  return true;
+}
+
+TextDialog::ElementTextQuery::ElementTextQuery(std::string title, const element **target, std::string _description) :
+    Dialog::ElementQuery(title,target,_description)
 {}
 
Index: src/UIElements/TextDialog.hpp
===================================================================
--- src/UIElements/TextDialog.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/UIElements/TextDialog.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -13,4 +13,9 @@
 #include "UIElements/Dialog.hpp"
 
+class atom;
+class element;
+class molecule;
+class Vector;
+
 class TextDialog : public Dialog
 {
@@ -19,16 +24,34 @@
   virtual ~TextDialog();
 
-  virtual void queryInt(const char *, int *);
-  virtual void queryString(const char*, std::string *);
-  virtual void queryDouble(const char*, double*);
-  virtual void queryMolecule(const char*,molecule**,MoleculeListClass*);
-  virtual void queryVector(const char*,Vector *,const double * const,bool);
-  virtual void queryElement(const char*,const element **);
+  virtual void queryEmpty(const char *, std::string = "");
+  virtual void queryBoolean(const char *, bool *, std::string = "");
+  virtual void queryInt(const char *, int *, std::string = "");
+  virtual void queryString(const char*, std::string *, std::string = "");
+  virtual void queryDouble(const char*, double*, std::string = "");
+  virtual void queryAtom(const char*,atom**,std::string = "");
+  virtual void queryMolecule(const char*,molecule**,std::string = "");
+  virtual void queryVector(const char*,Vector *,const double * const,bool, std::string = "");
+  virtual void queryBox(const char*,double ** const, std::string = "");
+  virtual void queryElement(const char*,const element **, std::string = "");
 
 protected:
   // specialized stuff for text queries
+  class EmptyTextQuery : public Dialog::EmptyQuery {
+  public:
+    EmptyTextQuery(std::string title, std::string _description = NULL);
+    virtual ~EmptyTextQuery();
+    virtual bool handle();
+  };
+
+  class BooleanTextQuery : public Dialog::BooleanQuery {
+  public:
+    BooleanTextQuery(std::string title, bool *_target, std::string _description = NULL);
+    virtual ~BooleanTextQuery();
+    virtual bool handle();
+  };
+
   class IntTextQuery : public Dialog::IntQuery {
   public:
-    IntTextQuery(std::string title, int *_target);
+    IntTextQuery(std::string title, int *_target, std::string _description = NULL);
     virtual ~IntTextQuery();
     virtual bool handle();
@@ -37,5 +60,5 @@
   class DoubleTextQuery : public Dialog::DoubleQuery {
   public:
-    DoubleTextQuery(std::string title, double *_target);
+    DoubleTextQuery(std::string title, double *_target, std::string _description = NULL);
     virtual ~DoubleTextQuery();
     virtual bool handle();
@@ -44,6 +67,13 @@
   class StringTextQuery : public Dialog::StringQuery {
   public:
-    StringTextQuery(std::string title, std::string *_target);
+    StringTextQuery(std::string title, std::string *_target, std::string _description = NULL);
     virtual ~StringTextQuery();
+    virtual bool handle();
+  };
+
+  class AtomTextQuery : public Dialog::AtomQuery {
+  public:
+    AtomTextQuery(std::string title, atom **_target, std::string _description = NULL);
+    virtual ~AtomTextQuery();
     virtual bool handle();
   };
@@ -51,5 +81,5 @@
   class MoleculeTextQuery : public Dialog::MoleculeQuery {
   public:
-    MoleculeTextQuery(std::string title, molecule **_target, MoleculeListClass *_molecules);
+    MoleculeTextQuery(std::string title, molecule **_target, std::string _description = NULL);
     virtual ~MoleculeTextQuery();
     virtual bool handle();
@@ -58,6 +88,13 @@
   class VectorTextQuery : public Dialog::VectorQuery {
   public:
-    VectorTextQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check);
+    VectorTextQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description = NULL);
     virtual ~VectorTextQuery();
+    virtual bool handle();
+  };
+
+  class BoxTextQuery : public Dialog::BoxQuery {
+  public:
+    BoxTextQuery(std::string title,double ** const _cellSize, std::string _description = NULL);
+    virtual ~BoxTextQuery();
     virtual bool handle();
   };
@@ -65,5 +102,5 @@
   class ElementTextQuery : public Dialog::ElementQuery {
   public:
-    ElementTextQuery(std::string title, const element **_target);
+    ElementTextQuery(std::string title, const element **_target, std::string _description = NULL);
     virtual ~ElementTextQuery();
     virtual bool handle();
Index: src/UIElements/TextUIFactory.cpp
===================================================================
--- src/UIElements/TextUIFactory.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/UIElements/TextUIFactory.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -27,6 +27,6 @@
 }
 
-MainWindow* TextUIFactory::makeMainWindow(menuPopulaters populaters,MoleculeListClass *molecules, config *configuration, periodentafel *periode, char *ConfigFileName) {
-  return new TextWindow(populaters,molecules,configuration,periode,ConfigFileName);
+MainWindow* TextUIFactory::makeMainWindow() {
+  return new TextWindow();
 }
 
Index: src/UIElements/TextUIFactory.hpp
===================================================================
--- src/UIElements/TextUIFactory.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/UIElements/TextUIFactory.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -19,5 +19,5 @@
 
   virtual Dialog* makeDialog();
-  virtual MainWindow* makeMainWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *);
+  virtual MainWindow* makeMainWindow();
 
 protected:
Index: src/UIElements/TextWindow.cpp
===================================================================
--- src/UIElements/TextWindow.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/UIElements/TextWindow.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -27,4 +27,5 @@
 #include "molecule.hpp"
 #include "periodentafel.hpp"
+#include "World.hpp"
 
 #include "Legacy/oldmenu.hpp"
@@ -38,4 +39,5 @@
 #include "UIElements/TextStatusIndicator.hpp"
 #include "Actions/MethodAction.hpp"
+#include "Actions/MoleculeAction/ChangeNameAction.hpp"
 #include "Actions/ErrorAction.hpp"
 #include "Actions/ActionRegistry.hpp"
@@ -48,6 +50,10 @@
 
 // TODO: see what code can be moved to a base class for Graphic and Text Windows
-TextWindow::TextWindow(menuPopulaters populaters,MoleculeListClass *molecules, config *configuration, periodentafel *periode, char *ConfigFileName)
+TextWindow::TextWindow()
 {
+  MoleculeListClass *molecules = World::getInstance().getMolecules();
+  config *configuration = World::getInstance().getConfig();
+  periodentafel *periode = World::getInstance().getPeriode();
+  char *ConfigFileName = NULL;
   old_menu = new oldmenu;
 
@@ -101,5 +107,5 @@
   // call all functions used to build the submenus
 
-  populaters.MakeEditMoleculesMenu(editMoleculesMenu,molecules,configuration,periode);
+  populateEditMoleculesMenu(editMoleculesMenu);
 
   Action *returnFromEditMoleculeAction = new TextMenu::LeaveAction(editMoleculesMenu);
@@ -125,2 +131,28 @@
   main_menu->display();
 }
+
+void TextWindow::populateEditMoleculesMenu(Menu* editMoleculesMenu)
+{
+  MoleculeListClass *molecules = World::getInstance().getMolecules();
+  periodentafel *periode = World::getInstance().getPeriode();
+
+  // build the EditMoleculesMenu
+  Action *createMoleculeAction = new MethodAction("createMoleculeAction",boost::bind(&MoleculeListClass::createNewMolecule,molecules,periode));
+  new ActionMenuItem('c',"create new molecule",editMoleculesMenu,createMoleculeAction);
+
+  Action *loadMoleculeAction = new MethodAction("loadMoleculeAction",boost::bind(&MoleculeListClass::loadFromXYZ,molecules,periode));
+  new ActionMenuItem('l',"load molecule from xyz file",editMoleculesMenu,loadMoleculeAction);
+
+  Action *changeFilenameAction = new MoleculeChangeNameAction();
+  new ActionMenuItem('n',"change molecule's name",editMoleculesMenu,changeFilenameAction);
+
+  Action *giveFilenameAction = new MethodAction("giveFilenameAction",boost::bind(&MoleculeListClass::setMoleculeFilename,molecules));
+  new ActionMenuItem('N',"give molecules filename",editMoleculesMenu,giveFilenameAction);
+
+  Action *parseAtomsAction = new MethodAction("parseAtomsAction",boost::bind(&MoleculeListClass::parseXYZIntoMolecule,molecules));
+  new ActionMenuItem('p',"parse atoms in xyz file into molecule",editMoleculesMenu,parseAtomsAction);
+
+  Action *eraseMoleculeAction = new MethodAction("eraseMoleculeAction",boost::bind(&MoleculeListClass::eraseMolecule,molecules));
+  new ActionMenuItem('r',"remove a molecule",editMoleculesMenu,eraseMoleculeAction);
+
+}
Index: src/UIElements/TextWindow.hpp
===================================================================
--- src/UIElements/TextWindow.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/UIElements/TextWindow.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -17,12 +17,16 @@
 class TextStatusIndicator;
 
+
 class TextWindow : public MainWindow
 {
 public:
-  TextWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *);
+  TextWindow();
   virtual ~TextWindow();
 
   virtual void display();
 private:
+  // populaters
+  void populateEditMoleculesMenu(Menu* editMoleculesMenu);
+
   TextMenu *main_menu;
 
Index: src/UIElements/UIFactory.cpp
===================================================================
--- src/UIElements/UIFactory.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/UIElements/UIFactory.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -13,4 +13,5 @@
 // all factories that can be used:
 #include "UIElements/TextUIFactory.hpp"
+#include "UIElements/CommandLineUIFactory.hpp"
 
 UIFactory::UIFactory()
@@ -30,4 +31,7 @@
       setInstance(new TextUIFactory());
       break;
+    case CommandLine:
+      setInstance(new CommandLineUIFactory());
+      break;
 
     default:
Index: src/UIElements/UIFactory.hpp
===================================================================
--- src/UIElements/UIFactory.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/UIElements/UIFactory.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -11,10 +11,5 @@
 class MainWindow;
 class Dialog;
-
-class MoleculeListClass;
-class config;
-class periodentafel;
-
-struct menuPopulaters;
+class DialogDescription;
 
 #include "Patterns/Singleton.hpp"
@@ -31,5 +26,5 @@
 
 public:
-  enum InterfaceTypes {Text};
+  enum InterfaceTypes {Text, CommandLine};
   virtual ~UIFactory();
 
@@ -37,5 +32,5 @@
    * Produce some kind of main window, of whichever type was chosen when the factory was created
    */
-  virtual MainWindow* makeMainWindow(menuPopulaters,MoleculeListClass *, config *, periodentafel *, char *)=0;
+  virtual MainWindow* makeMainWindow()=0;
 
   /**
Index: src/World.cpp
===================================================================
--- src/World.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/World.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -9,4 +9,5 @@
 
 #include "atom.hpp"
+#include "config.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
@@ -27,4 +28,8 @@
 }
 
+config *&World::getConfig(){
+  return configuration;
+}
+
 // Atoms
 
@@ -53,4 +58,8 @@
 std::vector<molecule*> World::getAllMolecules(MoleculeDescriptor descriptor){
   return descriptor.findAll();
+}
+
+std::vector<molecule*> World::getAllMolecules(){
+  return getAllMolecules(AllMolecules());
 }
 
@@ -267,4 +276,5 @@
 World::World() :
     periode(new periodentafel),
+    configuration(new config),
     atoms(),
     currAtomId(0),
@@ -292,4 +302,5 @@
   delete molecules_deprecated;
   delete periode;
+  delete configuration;
   MoleculeSet::iterator molIter;
   for(molIter=molecules.begin();molIter!=molecules.end();++molIter){
Index: src/World.hpp
===================================================================
--- src/World.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/World.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -30,4 +30,5 @@
 
 // forward declarations
+class config;
 class periodentafel;
 class MoleculeListClass;
@@ -75,4 +76,9 @@
 
   /**
+   * returns the configuration for the world.
+   */
+  config *&getConfig();
+
+  /**
    * returns the first atom that matches a given descriptor.
    * Do not rely on ordering for descriptors that match more than one atom.
@@ -109,4 +115,5 @@
    */
   std::vector<molecule*> getAllMolecules(MoleculeDescriptor descriptor);
+  std::vector<molecule*> getAllMolecules();
 
   /**
@@ -234,4 +241,5 @@
 
   periodentafel *periode;
+  config *configuration;
   static double *cell_size;
   static char *defaultName;
Index: src/atom_bondedparticle.cpp
===================================================================
--- src/atom_bondedparticle.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/atom_bondedparticle.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -74,4 +74,20 @@
       *BondFile << nr << "\t" << (*Runner)->GetOtherAtom(this)->nr << "\n";
 };
+
+/**
+ * Adds a bond between this bonded particle and another. Does nothing if this
+ * bond already exists.
+ *
+ * \param bonding partner
+ */
+void BondedParticle::addBond(BondedParticle* Partner) {
+  if (IsBondedTo(Partner)) {
+    return;
+  }
+
+  bond* newBond = new bond((atom*) this, (atom*) Partner, 1, 0);
+  RegisterBond(newBond);
+  Partner->RegisterBond(newBond);
+}
 
 /** Puts a given bond into atom::ListOfBonds.
Index: src/atom_bondedparticle.hpp
===================================================================
--- src/atom_bondedparticle.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/atom_bondedparticle.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -37,4 +37,5 @@
   virtual ~BondedParticle();
 
+  void addBond(BondedParticle* Partner);
   bool RegisterBond(bond *Binder);
   bool UnregisterBond(bond *Binder);
Index: src/atom_particleinfo.cpp
===================================================================
--- src/atom_particleinfo.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/atom_particleinfo.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -16,5 +16,8 @@
     nr(pointer->nr),
     Name(pointer->Name)
-    {}
+    {
+      if (Name == NULL)
+        Name = " ";
+    }
 
 
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/bond.cpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -15,5 +15,7 @@
 /** Empty Constructor for class bond.
  */
-bond::bond() : leftatom(NULL), rightatom(NULL), previous(NULL), next(NULL), HydrogenBond(0), BondDegree(0), nr(-1), Cyclic(false), Type(Undetermined), Used(white)
+bond::bond()
+  : leftatom(NULL), rightatom(NULL), previous(NULL), next(NULL), HydrogenBond(0),
+    BondDegree(0), nr(-1), Cyclic(false), Type(Undetermined), Used(white)
 {
 };
@@ -25,5 +27,7 @@
  * \param number increasing index
  */
-bond::bond(atom *left, atom *right, const int degree, const int number) : leftatom(left), rightatom(right), previous(NULL), next(NULL), HydrogenBond(0), BondDegree(degree), nr(number), Cyclic(false), Type(Undetermined), Used(white)
+bond::bond(atom *left, atom *right, const int degree, const int number)
+  : leftatom(left), rightatom(right), previous(NULL), next(NULL), HydrogenBond(0),
+    BondDegree(degree), nr(number), Cyclic(false), Type(Undetermined), Used(white)
 {
   if ((left != NULL) && (right != NULL)) {
Index: src/bondgraph.hpp
===================================================================
--- src/bondgraph.hpp	(revision 12872df33639e521d4b0225d6064ea91bd4f18e8)
+++ src/bondgraph.hpp	(revision f941b14c7a92d23575eccdfcd7bbb7ef127d1bad)
@@ -27,5 +27,5 @@
 
 class molecule;
-class periodentafel;
+class BondedParticle;
 class MatrixContainer;
 
